<%-- Copyright (c) 2003 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved. --%>
<%@include file="default.inc"%>
<%@page import="com.sas.solutions.spm.webapp.common.i18n.RB,
                java.util.Collections,
                java.util.Comparator,
                java.util.List,
                java.util.Locale,
                java.util.ArrayList,
                java.util.Map,
                javax.swing.tree.TreeModel,
                com.sas.servlet.tbeans.html.TreeView,
                com.sas.servlet.tbeans.models.TreeNode,
                com.sas.servlet.tbeans.models.TreeNodeInterface,
                com.sas.servlet.tbeans.StyleInfo,
                com.sas.framework.webapp.util.ThemeHelper,
                com.sas.webapp.themes.ThemeException,
                com.sas.webapp.themes.Theme,
                com.sas.solutions.spm.webapp.scorecards.beans.CurrentContext,
                com.sas.solutions.spm.webapp.common.util.SpmWebKey,
                com.sas.solutions.spm.core.persistence.domain.Scorecard,
                com.sas.solutions.spm.core.persistence.operations.ScorecardOperationLite,
                com.sas.solutions.spm.core.persistence.operations.AscendingNameComparator"%>
<html>
<head>
<sas-ui:ThemeStyles />
</head>
<body class="dataEntryBg">

<%
    String start = request.getParameter("start");
    boolean isPostBack = ((start == null) || (!start.equals("1")));
    isPostBack = false;

    TreeView view = (TreeView)session.getAttribute(SpmWebKey.SPM_TV_SCSPRJ);
    view.setRequest(request);

    Map nodeMap = (Map)session.getAttribute(SpmWebKey.SPM_TV_SCSPRJNODES);

    String tpId = (String)session.getAttribute(SpmWebKey.SPM_KPI_TEMPLATEID);
    String pjId = (String)session.getAttribute(SpmWebKey.SPM_KPI_PROJECTID);
    String sessionId = (String)session.getAttribute(SpmWebKey.SPM_SESSION_ID);
	CurrentContext ctx = (CurrentContext)session.getAttribute(SpmWebKey.SPM_CURRENT_CONTEXT_SCORECARD);

    if (isPostBack)  // treeview postback
    {
        String sname = null;
        java.util.Enumeration enum = request.getParameterNames();
        while (enum.hasMoreElements())
        {
            sname = (String)enum.nextElement();
            if (sname.endsWith("_childrenOf")) break;
            sname = null;
        }
        if (sname != null)
        {
            String id = request.getParameter(sname);
            TreeNode node = (TreeNode)nodeMap.get(id);
            TreeNode firstChild = (TreeNode)node.getFirstChild();
            if ("fake".equals(firstChild.getName()))
            {
                node.removeAllChildren();
                ScorecardOperationLite sol = new ScorecardOperationLite(sessionId);

                List children = sol.getAllImmediateChildScorecardsForScorecardId(id);
                List grandchildren = null;

                String lanid = null;
				if(ctx != null)
				    lanid = (String) ctx.getCurrentLanguageId();
				else
					lanid = (String)session.getAttribute(SpmWebKey.SPM_SORT_LANGUAGE_ID);

                String prefix = request.getContextPath() +
                                    "/Scorecards.do?o1=" +
                                    SpmWebKey.SPM_KEEP_SCORECARD_TREE +
                                    "&o2=" +
                                    SpmWebKey.SPM_REFRESH_SCORECARD_TABLE +
                                    "&st=" +
                                    ctx.getInnerTab() +
                                    "&tb=" +
                                    ctx.getTableId();

                String url = "javascript:brwSubmit('" + prefix + "&tv=1&tp="+tpId+"&pj="+pjId+"&sc=";
                TreeNode child;
                Scorecard c;

                //Comparator nameComparator = (Comparator)session.getAttribute(SpmWebKey.SPM_SORTER_CLASS);
                //if (nameComparator == null)
                //{
                //    nameComparator = new AscendingNameComparator( (String)session.getAttribute(SpmWebKey.SPM_SORT_LANGUAGE_ID), (Locale)session.getAttribute(SpmWebKey.SPM_SORT_LOCALE_ID) );
                //    session.setAttribute(SpmWebKey.SPM_SORTER_CLASS,nameComparator);
                //}
                //Collections.sort(children, nameComparator);

                String nodeImage = SpmWebKey.SPM_TREEVIEWIMG_KPI_SCORECARD;
                String nodeImageDis = SpmWebKey.SPM_TREEVIEWIMG_KPI_SCORECARDDIS;

                for (int i=0;i<children.size();i++)
                {
                    c = (Scorecard)children.get(i);
                    child = new TreeNode(id=c.getId(),c.getName(lanid));
                    if (c.isAccessDenied())
                    {
                        child.setDefaultImage(nodeImageDis);
                        child.setExpandedImage(nodeImageDis);
                    }
                    else
                    {
                        child.setDefaultImage(nodeImage);
                        child.setExpandedImage(nodeImage);
                        child.setURL(url + id + "')");
                    }
                    child.setNodeCellStyleClass("progr_treecellstyle");
                    grandchildren = sol.getAllImmediateChildScorecardsForScorecardId(id);
                    if (grandchildren.size() > 0)
                        child.add(new TreeNode("fake","fake"));
//                    else
//                        child.setLastNode(true);
                    node.add(child);
                    nodeMap.put(id,child);
                }
            }
        }
    }
    else
    {
        view.setId(SpmWebKey.SPM_TV_SCSPRJ);
        view.setNodeLoading(TreeView.PROGRESSIVE);
        view.setSelectionMode(TreeView.SINGLE_SELECTION);
        String imgLoc = "";
        try
        {
            imgLoc = ThemeHelper.getThemePath(Theme.ELEMENT_TYPE_IMAGE, true, request);
        }
        catch(ThemeException te) {}
        view.setImageLocation(imgLoc);
        view.setUsingURLLinks(true);
        view.setRootNodeVisible(false);
        view.setImageVisible(true);
        view.setTarget("_self");
        Map map = view.getStyleMap();
        map.put(TreeView.TREEVIEW_TEXT, new StyleInfo("progr_treeText"));
        map.put(TreeView.TREEVIEW_SELECTED, new StyleInfo("progr_treeSelected"));
        map.put(TreeView.TREEVIEW_LINK, new StyleInfo("progr_treeLink"));
    }
    view.write(out);
%>
<script language="javascript">
<!--
   function brwSubmit(url)
   {
        var doc = window.top.document;
        doc.getElementById("<%=SpmWebKey.SPM_TV_CLICKNODE%>").value = "true";
        var frm = doc.getElementById("fMainTree");
        frm.action = url;
        frm.submit();
		window.parent.disableEverything();
   }

   document.location.hash = '<%=ctx.getScorecardId()%>';

//-->
</script>
</body>
</html>
